--CONP - Pivoted View of up to 6 most appropriate Emergency contacts - Custom View - Aeries Software - Jared Kuszewski
--(CON.OR sort order is used while using "Lives With", "Access to Portal", "Ed Rights Holder", and "Primary Contact" to bump priority to be listed first from left to right)
--LINE 139 can be unremarked and used to further limit to specific CON.RL relation types of your choice
--Create CONP Custom View if not present - Run line 6 if you wish to drop a prior CONP rendition before I added version control
/* 
drop view CONP; delete from ctf where tc = 'CONP'; delete from ctd where tc = 'CONP';
*/
declare @version varchar(23) = '2019-02-13 20:00:00.000' --Specify a date in the distant future like 2199-01-01 to block revisions if you have customized this

set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'CONP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'CONP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale CONP view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''CONP''and o.[type_desc] = ''VIEW'') begin drop view CONP end; delete from ctf where tc = ''CONP''; delete from ctd where tc = ''CONP'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
create view CONP as
--CONP - Pivoted View of up to 6 most appropriate Emergency contacts - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
SELECT PID ID, 
ISNULL(MAX(CASEWHENC.ROWNUM=1THENRLELSENULLEND),'''')ASRL1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENCDELSENULLEND),'''')ASCD1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENNMELSENULLEND),'''')ASNM1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENFNELSENULLEND),'''')ASFN1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENLNELSENULLEND),'''')ASLN1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENTLELSENULLEND),'''')ASTL1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENCPELSENULLEND),'''')ASCP1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENWPELSENULLEND),'''')ASWP1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENEMELSENULLEND),'''')ASEM1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENADELSENULLEND),'''')ASAD1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENCYELSENULLEND),'''')ASCY1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENSTELSENULLEND),'''')ASST1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THENZCELSENULLEND),'''')ASZC1,
ISNULL(MAX(CASEWHENC.ROWNUM=1THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSENULLEND),'''')ASME1,

ISNULL(MAX(CASEWHENC.ROWNUM=2THENRLELSENULLEND),'''')ASRL2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENCDELSENULLEND),'''')ASCD2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENNMELSENULLEND),'''')ASNM2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENFNELSENULLEND),'''')ASFN2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENLNELSENULLEND),'''')ASLN2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENTLELSENULLEND),'''')ASTL2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENCPELSENULLEND),'''')ASCP2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENWPELSENULLEND),'''')ASWP2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENEMELSENULLEND),'''')ASEM2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENADELSENULLEND),'''')ASAD2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENCYELSENULLEND),'''')ASCY2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENSTELSENULLEND),'''')ASST2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THENZCELSENULLEND),'''')ASZC2,
ISNULL(MAX(CASEWHENC.ROWNUM=2THEN REPLACE(REPLACE(REPLACE(REPLACE(ME,CHAR(13)+CHAR(10),'' ''),CHAR(13),'' ''),CHAR(10),'' ''),CHAR(9),'' '') ELSENULLEND),'''')ASME2,

ISNULL(MAX(CASEWHENC.ROWNUM=3THENRLELSENULLEND),'''')ASRL3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENCDELSENULLEND),'''')ASCD3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENNMELSENULLEND),'''')ASNM3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENFNELSENULLEND),'''')ASFN3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENLNELSENULLEND),'''')ASLN3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENTLELSENULLEND),'''')ASTL3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENCPELSENULLEND),'''')ASCP3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENWPELSENULLEND),'''')ASWP3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENEMELSENULLEND),'''')ASEM3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENADELSENULLEND),'''')ASAD3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENCYELSENULLEND),'''')ASCY3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENSTELSENULLEND),'''')ASST3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THENZCELSENULLEND),'''')ASZC3,
ISNULL(MAX(CASEWHENC.ROWNUM=3THEN REPLACE(REPLACE(REPLACE(REPLACE(ME,CHAR(13)+CHAR(10),'' ''),CHAR(13),'' ''),CHAR(10),'' ''),CHAR(9),'' '') ELSENULLEND),'''')ASME3,
'

select @DynaQuery += N'
ISNULL(MAX(CASEWHENC.ROWNUM=4THENRLELSENULLEND),'''')ASRL4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENCDELSENULLEND),'''')ASCD4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENNMELSENULLEND),'''')ASNM4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENFNELSENULLEND),'''')ASFN4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENLNELSENULLEND),'''')ASLN4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENTLELSENULLEND),'''')ASTL4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENCPELSENULLEND),'''')ASCP4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENWPELSENULLEND),'''')ASWP4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENEMELSENULLEND),'''')ASEM4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENADELSENULLEND),'''')ASAD4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENCYELSENULLEND),'''')ASCY4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENSTELSENULLEND),'''')ASST4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THENZCELSENULLEND),'''')ASZC4,
ISNULL(MAX(CASEWHENC.ROWNUM=4THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSENULLEND),'''')ASME4,

ISNULL(MAX(CASEWHENC.ROWNUM=5THENRLELSENULLEND),'''')ASRL5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENCDELSENULLEND),'''')ASCD5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENNMELSENULLEND),'''')ASNM5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENFNELSENULLEND),'''')ASFN5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENLNELSENULLEND),'''')ASLN5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENTLELSENULLEND),'''')ASTL5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENCPELSENULLEND),'''')ASCP5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENWPELSENULLEND),'''')ASWP5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENEMELSENULLEND),'''')ASEM5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENADELSENULLEND),'''')ASAD5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENCYELSENULLEND),'''')ASCY5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENSTELSENULLEND),'''')ASST5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THENZCELSENULLEND),'''')ASZC5,
ISNULL(MAX(CASEWHENC.ROWNUM=5THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSENULLEND),'''')ASME5,

ISNULL(MAX(CASEWHENC.ROWNUM=6THENRLELSENULLEND),'''')ASRL6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENCDELSENULLEND),'''')ASCD6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENNMELSENULLEND),'''')ASNM6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENFNELSENULLEND),'''')ASFN6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENLNELSENULLEND),'''')ASLN6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENTLELSENULLEND),'''')ASTL6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENCPELSENULLEND),'''')ASCP6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENWPELSENULLEND),'''')ASWP6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENEMELSENULLEND),'''')ASEM6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENADELSENULLEND),'''')ASAD6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENCYELSENULLEND),'''')ASCY6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENSTELSENULLEND),'''')ASST6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THENZCELSENULLEND),'''')ASZC6,
ISNULL(MAX(CASEWHENC.ROWNUM=6THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSENULLEND),'''')ASME6,

0 DEL,
CURRENT_TIMESTAMP DTS
FROM 
(SELECT 
ROW_NUMBER() OVER (PARTITION BY PID ORDER BY 
[OR] 
- CASE WHEN PC = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN AP = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN LW = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN ERH = ''Y'' THEN 1 ELSE 0 END) 
-- CASE WHEN  c1d <> '''' or c2d <> '''' THEN 1 ELSE 0 END --Take away the dash so this line begins like the one above if contact linking also makes them a more prominent contact?
ROWNUM,
PID, RL, CD, NM, FN, LN, TL, CP, WP, EM, AD, CY, ST, ZC, ME
FROM CON 

WHERE DEL = 0 AND RF <> 1 
--AND RL IN (''10'',''11'') --LIMIT TO SPECIFIC RELATIONSHIP CODES WITH THIS LINE IF DESIRED 
AND CD NOT IN (SELECT CD FROM COD WHERE TC = ''CON'' AND FC = ''CD'' AND DEL = 0 AND N1 = 9)
AND PID IN (SELECT DISTINCT ID FROM STU WHERE DEL = 0)
) C
GROUP BY PID
'



--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


insert CTD (TC, NM, NLC, PKF, PT, PF, CF, OM, OB, VW)
select 'CONP','Contacts On One Line (Pivoted)','','ID','STU','ID','ID','One','ID','1'

insert ctf (TC, FC, SQ, NM, TY, DL)
values 
('CONP','RL1','1','Contact 1 Relation Code','Text','600'),
('CONP','CD1','3','Contact 1 Code','Text','600'),
('CONP','NM1','5','Contact 1 Full Name','Text','600'),
('CONP','FN1','7','Contact 1 First Name','Text','600'),
('CONP','LN1','9','Contact 1 Last Name','Text','600'),
('CONP','TL1','11','Contact 1 Telephone','Text','600'),
('CONP','CP1','13','Contact 1 Cell Phone','Text','600'),
('CONP','WP1','15','Contact 1 Work Phone','Text','600'),
('CONP','EM1','17','Contact 1 email','Text','600'),
('CONP','AD1','19','Contact 1 Address','Text','600'),
('CONP','CY1','21','Contact 1 City','Text','600'),
('CONP','ST1','23','Contact 1 State','Text','600'),
('CONP','ZC1','25','Contact 1 ZIP code','Text','600'),
('CONP','ME1','27','Contact 1 Memo','Text','600'),
('CONP','RL2','29','Contact 2 Relation Code','Text','600'),
('CONP','CD2','31','Contact 2 Code','Text','600'),
('CONP','NM2','33','Contact 2 Full Name','Text','600'),
('CONP','FN2','35','Contact 2 First Name','Text','600'),
('CONP','LN2','37','Contact 2 Last Name','Text','600'),
('CONP','TL2','39','Contact 2 Telephone','Text','600'),
('CONP','CP2','41','Contact 2 Cell Phone','Text','600'),
('CONP','WP2','43','Contact 2 Work Phone','Text','600'),
('CONP','EM2','45','Contact 2 email','Text','600'),
('CONP','AD2','47','Contact 2 Address','Text','600'),
('CONP','CY2','49','Contact 2 City','Text','600'),
('CONP','ST2','51','Contact 2 State','Text','600'),
('CONP','ZC2','53','Contact 2 ZIP code','Text','600'),
('CONP','ME2','55','Contact 2 Memo','Text','600'),
('CONP','RL3','57','Contact 3 Relation Code','Text','600'),
('CONP','CD3','59','Contact 3 Code','Text','600'),
('CONP','NM3','61','Contact 3 Full Name','Text','600'),
('CONP','FN3','63','Contact 3 First Name','Text','600'),
('CONP','LN3','65','Contact 3 Last Name','Text','600'),
('CONP','TL3','67','Contact 3 Telephone','Text','600'),
('CONP','CP3','69','Contact 3 Cell Phone','Text','600'),
('CONP','WP3','71','Contact 3 Work Phone','Text','600'),
('CONP','EM3','73','Contact 3 email','Text','600'),
('CONP','AD3','75','Contact 3 Address','Text','600'),
('CONP','CY3','77','Contact 3 City','Text','600'),
('CONP','ST3','79','Contact 3 State','Text','600'),
('CONP','ZC3','81','Contact 3 ZIP code','Text','600'),
('CONP','ME3','83','Contact 3 Memo','Text','600'),
('CONP','RL4','85','Contact 4 Relation Code','Text','600'),
('CONP','CD4','87','Contact 4 Code','Text','600'),
('CONP','NM4','89','Contact 4 Full Name','Text','600'),
('CONP','FN4','91','Contact 4 First Name','Text','600'),
('CONP','LN4','93','Contact 4 Last Name','Text','600'),
('CONP','TL4','95','Contact 4 Telephone','Text','600'),
('CONP','CP4','97','Contact 4 Cell Phone','Text','600'),
('CONP','WP4','99','Contact 4 Work Phone','Text','600'),
('CONP','EM4','101','Contact 4 email','Text','600'),
('CONP','AD4','103','Contact 4 Address','Text','600'),
('CONP','CY4','105','Contact 4 City','Text','600'),
('CONP','ST4','107','Contact 4 State','Text','600'),
('CONP','ZC4','109','Contact 4 ZIP code','Text','600'),
('CONP','ME4','111','Contact 4 Memo','Text','600'),
('CONP','RL5','113','Contact 5 Relation Code','Text','600'),
('CONP','CD5','115','Contact 5 Code','Text','600'),
('CONP','NM5','117','Contact 5 Full Name','Text','600'),
('CONP','FN5','119','Contact 5 First Name','Text','600'),
('CONP','LN5','121','Contact 5 Last Name','Text','600'),
('CONP','TL5','123','Contact 5 Telephone','Text','600'),
('CONP','CP5','125','Contact 5 Cell Phone','Text','600'),
('CONP','WP5','127','Contact 5 Work Phone','Text','600'),
('CONP','EM5','129','Contact 5 email','Text','600'),
('CONP','AD5','131','Contact 5 Address','Text','600'),
('CONP','CY5','133','Contact 5 City','Text','600'),
('CONP','ST5','135','Contact 5 State','Text','600'),
('CONP','ZC5','137','Contact 5 ZIP code','Text','600'),
('CONP','ME5','139','Contact 5 Memo','Text','600'),
('CONP','RL6','141','Contact 6 Relation Code','Text','600'),
('CONP','CD6','143','Contact 5 Code','Text','600'),
('CONP','NM6','145','Contact 6 Full Name','Text','600'),
('CONP','FN6','147','Contact 6 First Name','Text','600'),
('CONP','LN6','149','Contact 6 Last Name','Text','600'),
('CONP','TL6','151','Contact 6 Telephone','Text','600'),
('CONP','CP6','153','Contact 6 Cell Phone','Text','600'),
('CONP','WP6','155','Contact 6 Work Phone','Text','600'),
('CONP','EM6','157','Contact 6 email','Text','600'),
('CONP','AD6','159','Contact 6 Address','Text','600'),
('CONP','CY6','161','Contact 6 City','Text','600'),
('CONP','ST6','163','Contact 6 State','Text','600'),
('CONP','ZC6','165','Contact 6 ZIP code','Text','600'),
('CONP','ME6','167','Contact 6 Memo','Text','600')

insert CTF (TC, FC, SQ)
select top (select count(*) - 1 from ctf where tc = 'CONP') 
'CONP' TC, FC = 'NEWLINE' + cast(row_number() over (order by sq) as varchar(4)),
sq + 1 SQ
from ctf where tc = 'CONP'

print 'CONP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of CONP blocked by version control - CONP needs no update or was customized.'
set nocount off


